package persistenza;

import java.sql.*;

public class DataSource {

    private static String databaseURI = "jdbc:postgresql:automobili";
    private static String userName = "pguser";
    private static String password = "pguser";

    static {
        try {
            Driver driver = new org.postgresql.Driver();
            DriverManager.registerDriver(driver);
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    private DataSource() {}

    public static Connection getConnection() throws SQLException {
        Connection connection = DriverManager.getConnection(databaseURI, userName, password);
        return connection;
    }

    public static void close(Connection connection) {
        try {
            if (connection != null) {
                connection.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    public static void close(Statement statement) {
        try {
            if (statement != null) {
                statement.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

    public static void close(ResultSet resultSet) {
        try {
            if (resultSet != null) {
                resultSet.close();
            }
        } catch (SQLException sqle) {
            System.err.println(sqle);
        }
    }

}
