/*
    pinco - a didactic framework for Web development
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ----
    pinco - un framework didattico per lo sviluppo Web
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it
 
    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.
 
    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.
 
    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA
 
 */

package it.unibas.pinco.framework;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import org.w3c.dom.*;

public class MappaDelleAzioni{
    
    private String azioneIniziale;
    private String azioneFinale;
    private java.util.HashMap mappaDelleAzioni;
     
    public String getAzioneIniziale() {
        return this.azioneIniziale;
    }
    
    public String getAzioneFinale() {
        return this.azioneFinale;
    }

    /*
    public java.util.HashMap getMappaDelleAzioni(){
        return this.mappaDelleAzioni;
    }
    */
    
    public String getAzione(String comando) {
        DescrittoreAzione descrittoreAzione = (DescrittoreAzione)mappaDelleAzioni.get(comando);
        String azione = null;
        if (descrittoreAzione != null) {
            azione = descrittoreAzione.getAzione();
        }
        return azione;
    }
    
    public String getSchermoSuccessivo(String comando, String esito) {
        DescrittoreAzione descrittoreAzione = (DescrittoreAzione)mappaDelleAzioni.get(comando);
        String schermoSuccessivo = null;
        if (descrittoreAzione != null) {
            schermoSuccessivo = descrittoreAzione.getSchermoSuccessivo(esito);
        }
        return schermoSuccessivo;
    }
    
    public void carica(String nomeFile) throws PincoException {
        boolean caricata = false;
        mappaDelleAzioni = new java.util.HashMap();
        Document document = null;
        try {
            document = creaDocument(nomeFile);
        } catch (org.xml.sax.SAXException sxe) {
            sxe.printStackTrace();
            throw new PincoException(sxe);
        } catch (ParserConfigurationException pce) {
            pce.printStackTrace();
            throw new PincoException(pce);
        } catch (java.io.IOException ioe) {
            ioe.printStackTrace();
            throw new PincoException(ioe);
        }
        caricaAzioneIniziale(document);
        caricaAzioneFinale(document);
        caricaAzioni(document);
        //System.out.println(mappaDelleAzioni+"");
    }
    
    private Document creaDocument(String nomeFile) throws ParserConfigurationException,
                                                          SAXException, java.io.IOException {
        Document document = null;
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        document = builder.parse(new java.io.File(nomeFile));
        return document;
    }
    
    private void caricaAzioneIniziale(Document document) {
        Element root = document.getDocumentElement();
        NodeList listaNodiAzioneIniziale = root.getElementsByTagName("azioneIniziale");
        if (listaNodiAzioneIniziale.getLength() != 0) { 
            Element elementoAzioneIniziale = (Element)listaNodiAzioneIniziale.item(0);
            this.azioneIniziale = elementoAzioneIniziale.getFirstChild().getNodeValue();
        }
    }

    private void caricaAzioneFinale(Document document) {
        Element root = document.getDocumentElement();
        NodeList listaNodiAzioneFinale = root.getElementsByTagName("azioneFinale");
        if (listaNodiAzioneFinale.getLength() != 0) { 
            Element elementoAzioneFinale = (Element)listaNodiAzioneFinale.item(0);
            this.azioneFinale = elementoAzioneFinale.getFirstChild().getNodeValue();
        }
    }

    private void caricaAzioni(Document document) {
        Element root = document.getDocumentElement();
        NodeList listaAzioni = root.getElementsByTagName("azioni");
        Element elementoAzioni = (Element)listaAzioni.item(0);
        NodeList listaDescrittori = elementoAzioni.getElementsByTagName("descrittoreAzione");
        for(int i = 0; i < listaDescrittori.getLength(); i++){
            Element elementoDescrittore = (Element)listaDescrittori.item(i);
            DescrittoreAzione descrittoreAzione = new DescrittoreAzione();
            String nomeComando = elementoDescrittore.getAttribute("comando");
            descrittoreAzione.setComando(nomeComando);
            String nomeAzione = elementoDescrittore.getAttribute("azione");
            descrittoreAzione.setAzione(nomeAzione);
            caricaSchermi(elementoDescrittore, descrittoreAzione);
            this.mappaDelleAzioni.put(nomeComando, descrittoreAzione);
        }
    }
    
    private void caricaSchermi(Element elementoDescrittore, DescrittoreAzione descrittoreAzione) {
        NodeList listaSchermi = elementoDescrittore.getElementsByTagName("schermoSuccessivo");
         for (int i = 0; i < listaSchermi.getLength(); i++) {
            Element elementoSchermo = (Element)listaSchermi.item(i);
            String esito = elementoSchermo.getAttribute("esito");
            String nomeSchermo = elementoSchermo.getFirstChild().getNodeValue();
            descrittoreAzione.addSchermoSuccessivo(esito, nomeSchermo);
        }
    }
}
