/*
    pinco - a didactic framework for Web development
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ----
    pinco - un framework didattico per lo sviluppo Web
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

package it.unibas.pinco.test;

import junit.framework.*;
import com.meterware.servletunit.*;
import com.meterware.httpunit.*;
import javax.servlet.*;
import javax.servlet.http.*;
import it.unibas.pinco.framework.Controllo;

public class TestControllo extends TestCase {
    
    public TestControllo(java.lang.String testName) {
        super(testName);
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(TestDescrittoreAzione.class);
        return suite;
    }
    
    // Add test methods here, they have to start with 'test' name.
    // for example:
    // public void testHello() {}
    
    private String webFile1 = Costanti.PERCORSO + "web1.xml";
    private String webFile2 = Costanti.PERCORSO + "web2.xml";
    
    public void testControllo1() throws Exception {
        //String nomeFile = this.getClass().getResource(webFile1).getPath();
        String nomeFile = webFile1;
        ServletRunner servletRunner = new ServletRunner(nomeFile);
        ServletUnitClient client = servletRunner.newClient();
        WebRequest webRequest = new GetMethodWebRequest("http://www.pinco.it/test1.cmd");
        InvocationContext invocationContext = client.newInvocation(webRequest);
        Controllo controllo = (Controllo)invocationContext.getServlet();
        assertTrue("inizializzato", controllo.getInizializzato());
        WebResponse webResponse = servletRunner.getResponse(webRequest);
        String corpo = webResponse.getText();
        assertTrue("completato", corpo.indexOf("Test 1 completato") != -1);
    }
        
    public void testControllo2() throws Exception {
        //String nomeFile = this.getClass().getResource(webFile2).getPath();
        String nomeFile = webFile2;
        ServletRunner servletRunner = new ServletRunner(nomeFile);
        ServletUnitClient client = servletRunner.newClient();
        WebRequest webRequest;
        webRequest = new GetMethodWebRequest("http://www.pinco.it/test2.cmd");
        InvocationContext invocationContext = client.newInvocation(webRequest);
        Controllo controllo = (Controllo)invocationContext.getServlet();
        assertTrue("inizializzato", controllo.getInizializzato());
        WebResponse webResponse = servletRunner.getResponse(webRequest);
        String corpo = webResponse.getText();
        assertTrue("completato", corpo.indexOf("Test 2 completato") != -1);
        webRequest = new GetMethodWebRequest("http://www.pinco.it/test1.cmd");
        invocationContext = client.newInvocation(webRequest);
        controllo = (Controllo)invocationContext.getServlet();
        webResponse = servletRunner.getResponse(webRequest);
        corpo = webResponse.getText();
        assertTrue("completato 2", corpo.indexOf("Test 1 completato") != -1);
    }
}

