/*
    pinco - a didactic framework for Web development
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ----
    pinco - un framework didattico per lo sviluppo Web
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

package it.unibas.pinco.test;

import junit.framework.*;
import it.unibas.pinco.framework.DescrittoreAzione;

public class TestDescrittoreAzione extends TestCase {
    
    public TestDescrittoreAzione(java.lang.String testName) {
        super(testName);
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(TestDescrittoreAzione.class);
        return suite;
    }
    
    // Add test methods here, they have to start with 'test' name.
    // for example:
    // public void testHello() {}
    
    private DescrittoreAzione descrittore;
    
    protected void setUp() {
        descrittore = new DescrittoreAzione();
    }
    
    public void testSetEGetAzione() {
        descrittore.setAzione("azione");
        assertTrue("get azione", descrittore.getAzione().equals("azione"));
    }

    public void testSetEGetComando() {
        descrittore.setComando("comando");
        assertTrue("get comando", descrittore.getComando().equals("comando"));
    }

    public void testAddeGetAzione() {
        String schermo;
        schermo = descrittore.getSchermoSuccessivo("esito1");
        assertTrue("schermo nullo", schermo == null);
        descrittore.addSchermoSuccessivo("esito1", "schermo1");
        schermo = descrittore.getSchermoSuccessivo("esito1");
        assertTrue("schermo1", schermo.equals("schermo1"));
        descrittore.addSchermoSuccessivo("esito2", "schermo2");
        schermo = descrittore.getSchermoSuccessivo("esito2");
        assertTrue("schermo2", schermo.equals("schermo2"));
    }
    
}
