/*
    pinco - a didactic framework for Web development
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ----
    pinco - un framework didattico per lo sviluppo Web
    Copyright (C) 2002-2003  Giansalvatore Mecca - mecca@unibas.it

    Questo  programma   software  libero;   lecito redistribuirlo  o
    modificarlo secondo i termini  della Licenza Pubblica Generica GNU
    come  pubblicata dalla Free  Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma   distribuito nella  speranza che sia  utile, ma
    SENZA  ALCUNA GARANZIA;  senza  neppure la  garanzia implicita  di
    NEGOZIABILIT  o di  APPLICABILIT PER  UN PARTICOLARE  SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Questo  programma deve  essere  distribuito assieme  ad una  copia
    della Licenza Pubblica Generica GNU;  in caso contrario, se ne pu
    ottenere  una scrivendo  alla Free  Software Foundation,  Inc., 59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA

*/

package it.unibas.pinco.test;

import junit.framework.*;
import it.unibas.pinco.framework.*;

public class TestMappaDelleAzioni extends TestCase {
    
    public TestMappaDelleAzioni(java.lang.String testName) {
        super(testName);
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(TestMappaDelleAzioni.class);
        return suite;
    }
    
    // Add test methods here, they have to start with 'test' name.
    // for example:
    // public void testHello() {}
    
    private MappaDelleAzioni mappaDelleAzioni;
    private String file1 = Costanti.PERCORSO + "azioni-pinco-test1.xml";
    private String file2 = Costanti.PERCORSO + "azioni-pinco-test2.xml";
    private String file3 = Costanti.PERCORSO + "azioni-pinco-test3.xml";
    
    protected void setUp() {
        this.mappaDelleAzioni = new MappaDelleAzioni();
    }
    
    public void testCarica1() throws PincoException {
        //String nomeFile = this.getClass().getResource(file1).getPath();
        String nomeFile = file1;
        mappaDelleAzioni.carica(nomeFile);
        assertTrue("azione iniziale", mappaDelleAzioni.getAzioneIniziale().equals("prova.ProvaAzioneIniziale"));
        assertTrue("azione finale", mappaDelleAzioni.getAzioneFinale().equals("prova.ProvaAzioneFinale"));
        assertTrue("azione 1", mappaDelleAzioni.getAzione("comando1.cmd").equals("prova.Comando1"));
        assertTrue("schermo 1", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo 2", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "esito2").equals("/schermo2.jsp"));
        assertTrue("schermo 3", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "esito3").equals("/schermo3.jsp"));
        assertTrue("schermo nullo", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "xxx") == null);
        assertTrue("azione 2", mappaDelleAzioni.getAzione("comando2.cmd").equals("prova.Comando2"));
        assertTrue("schermo 1", mappaDelleAzioni.getSchermoSuccessivo("comando2.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo nullo", mappaDelleAzioni.getSchermoSuccessivo("comando2.cmd", "xxx") == null);
    }

    public void testCarica2() throws PincoException {
        //String nomeFile = this.getClass().getResource(file2).getPath();
        String nomeFile = file2;
        mappaDelleAzioni.carica(nomeFile);
        assertTrue("azione iniziale", mappaDelleAzioni.getAzioneIniziale() == null);
        assertTrue("azione finale", mappaDelleAzioni.getAzioneFinale() == null);
        assertTrue("azione 1", mappaDelleAzioni.getAzione("comando1.cmd").equals("prova.Comando1"));
        assertTrue("schermo 1", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo 2", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "esito2").equals("/schermo2.jsp"));
        assertTrue("schermo 3", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "esito3").equals("/schermo3.jsp"));
        assertTrue("schermo nullo", mappaDelleAzioni.getSchermoSuccessivo("comando1.cmd", "xxx") == null);
        assertTrue("azione 2", mappaDelleAzioni.getAzione("comando2.cmd").equals("prova.Comando2"));
        assertTrue("schermo 1", mappaDelleAzioni.getSchermoSuccessivo("comando2.cmd", "esito1").equals("/schermo1.jsp"));
        assertTrue("schermo nullo", mappaDelleAzioni.getSchermoSuccessivo("comando2.cmd", "xxx") == null);
    }

    public void testCarica3() throws PincoException {
        //String nomeFile = this.getClass().getResource(file3).getPath();
        String nomeFile = file3;
        mappaDelleAzioni.carica(nomeFile);
        assertTrue("azione iniziale", mappaDelleAzioni.getAzioneIniziale() == null);
        assertTrue("azione finale", mappaDelleAzioni.getAzioneFinale() == null);
        assertTrue("azione 1", mappaDelleAzioni.getAzione("comando1.cmd") == null);
        assertTrue("azione 2", mappaDelleAzioni.getAzione("comando2.cmd") == null);
    }
}
